/* file yuml.conform.pl */


/* no empty names */

noEmptyNames:-forall(ename(I1,''),isError('class or interface with empty name ',I1)).

/* uniqueNames CONSTRAINT: Classes and Interfaces have unique names constraint */

findPair(I1,I2,N):-ename(I1,N),ename(I2,N),@I1 @< @I2.
uniqueNames:-forall(findPair(_,_,N),isError('unique names constraint violated: ',N)).


/* inh constraint -- no association can have ^ paired with anything else */

findTwo(Sub,Sup):-yumlAssociation(_,Sup,_,'^',Sub,_,A),not(A=='').
findTwo(Sub,Sup):-yumlAssociation(_,Sub,_,A,Sup,_,'^'),not(A=='').

badInheritance :- forall(findTwo(E1,E2),isError('inheritance paired with non-null end ',[E1,E2])).

/* another inheritance constraint -- no labels! */

nonblank(R1,R2):-not(R1='');not(R2='').
ilabel(Sub,Sup):-yumlAssociation(_,Sup,R1,'^',Sub,R2,_),nonblank(R1,R2).
ilabel(Sub,Sup):-yumlAssociation(_,Sub,R2,_,Sup,R1,'^'),nonblank(R1,R2).

noLabels:-forall(ilabel(A,B),isError('remove labels for inheritance ',[A,B])).



/* circular CONSTRAINT: Check circularity of class Hierarchy */

/*  utility predicates */
isClass(I,N):-yumlClass(I,N,_,_).
isIntf(I,N):-yumlInterface(I,N,_).
ename(I,N):-isIntf(I,N);isClass(I,N).

subclass(Sb,Sp):-yumlAssociation(_,Sp,_,'^',Sb,_,_),isClass(_,Sb),isClass(_,Sp).
subclass(Sb,Sp):-yumlAssociation(_,Sb,_,_,Sp,_,'^'),isClass(_,Sb),isClass(_,Sp).

subOf(Sub,Sup):-subclass(Sub,Sup).
subOf(Sub,Sup):-subclass(Sub,X),subOf(X,Sup).

testCycle(N):-subOf(N,N),!.

circular:-forall(testCycle(N),isError('circular class hierarchy contains ',N )).

/* icircular CONSTRAINT: Check circularity of inheritance Hierarchy  */

isubOfBase(Sub,Sup):-yumlAssociation(_,Sup,_,'^',Sub,_,''),isIntf(_,Sup),isIntf(_,Sub).
isubOfBase(Sub,Sup):-yumlAssociation(_,Sub,_,'',Sup,_,'^'),isIntf(_,Sup),isIntf(_,Sub).

isubOf(Sub,Sup):-isubOfBase(Sub,Sup).
isubOf(Sub,Sup):-isubOfBase(Sub,X),isubOf(X,Sup).

testICycle(I):-isubOf(I,I),!.

icircular:-forall(testICycle(N),isError('circular inheritance hierarchy contains ',N )).

/* ALL CONSTRAINTS */

run:-noEmptyNames,uniqueNames,circular, icircular, noLabels, badInheritance.
